divert(-1)
#
# These rules use a map rather than a text file.  More efficient
# if the map is large and sendmail does not need to be restarted.
# 
# /etc/relay created from a file with one entry per line
# containing the domain name you relay to followed by OK
#
# domain.com OK
# 
# makemap hash /etc/relay < relay_text_file
# 
# /etc/local created from a file with one entry per line
# containing the domain name you allow relays from followed by OK
#
# localhost OK
# your.domain OK
# your.virtual.domain.one OK
# your.virtual.domain.two OK
# 
# makemap hash /etc/local < local_text_file
#
#
# /etc/allowed created from a file with one entry per line
# containing user@domain that you will relay for followed by OK
#
# makemap hash /etc/allowed < allowed_text_file
#
divert(0)
VERSIONID(`@(#)check_rcpt.m4 $Id: check_rcpt.m4,v 1.7 1997/04/14 20:57:59 jc Exp jc $')
PUSHDIVERT(6)
Krelay ifelse(_ARG_, `', `hash /etc/relay', `_ARG_')
Klocal ifelse(_ARG_, `', `hash /etc/local', `_ARG_')
Kallowed ifelse(_ARG_, `', `hash /etc/allowed', `_ARG_')
POPDIVERT

divert(2)
LOCAL_RULESETS

SStart
R$* $$| $*		$: $1 $| $2

Srelay

R$*			$: $(relay $1$)		# lookup domain in database
ROK			$@ <OK>			# exists? return
R$* $-.$-.$+		$: $>relay $3.$4	# Strip one level of domain and try again

Slocal

R$*			$: $(local $1$)		# lookup domain in database
R<OK>			$@ <OK>			# Return if entry exists
R$-.$-.$+		$: $>local $2.$3		# Strip one level of domain and try again

Sallowed

R$+<@$+>		$: $1<@$(allowed $1@$2 $:$2$)> 	# lookup address in database
R$+<@OK>		$@ <OK>				# Return if entry exists
R$+<@$-.$-.$+>		$: $>allowed $1<@$3.$4>		# Strip one level of domain and try again

# from: $| to:
Scheck_rcpt

R$+ $| $+		$: $2 $| $>3 $1		# Canonify sender
R$+ $| $+		$: $2 $| $>3 $1		# Canonify recipient
R$+ $| $+		$: $2 $| $(dequote $1 $)# Clean up both
R$+ $| $+		$: $2 $| $(dequote $1 $)
R$+ $| $-		$@ ok			# To user name only
R$* $| $* < @ $- > $*	$#error $@ 5.1.8 $: 518 Invalid host name $3
R$+ $| $* % $*		$: relay attempt	# user%host@domain
R$+ $| $* @ $* @ $*	$: relay attempt	# @domain:user@domain
R$+ $| $* < @ $=w.> $*	$@ ok			# Class w domains

R$*<@$*.> $| $*		$: $1<@$2> $| $3	# Remove trailing ., if there
R$+ $| $+		$: $2 $| $>allowed $1	# Check allowed relays from user@domain
						# Work space is now to: $| result of $>allowed
R$+ $| <OK>		$@ ok
R$+ $| $+		$: $1			# Get the to: address
R$*<@$*.>		$: $1<@$2>		# Remove trailing ., if there
R$*<@$*>$*		$: $2			# Pick out the domain
R$+			$: $>relay $1		# See if we can relay to this domain
R<OK>			$@ ok

# Now look at the client and see if its allowed
#
R$+			$: $(dequote "" $&{client_name} $)
R$-			$@ ok			# Unqualified local names
R$*			$: $>local $1		# Check the database
ROK			$@ ok
R$*			$#error $@ 4.7.1 $: "471 we do not relay"

divert(0)
